<template>
  <b-container fluid class="mt-5">
    <b-card :header="caption">
      <div slot="header">Доступы
        <div class="card-header-actions">
          <button class="btn btn-primary btn-sm" @click="openAddingModal">
            <i class="icon-plus"></i>
          </button>
        </div>
      </div>
      <b-table
        :hover="hover"
        :striped="striped"
        :bordered="bordered"
        :small="small"
        responsive
        :items="tableData"
        :fields="fields"
        :current-page="currentPage"
        :per-page="perPage"
      >
        <template slot="action" slot-scope="data">
          <b-button size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn">
            <i class="icon-pencil"></i>
          </b-button>
          <b-button size="sm" @click="deleting(data.item._id)" class="mr-1 tableActionbtn">
            <i class="fa fa-trash"></i>
          </b-button>
          <!-- <b-btn class="mt-3" variant="outline-danger" block @click="deleting(modalInfo._id)">Удалить</b-btn> -->
        </template>
      </b-table>
      <nav>
        <b-pagination
          :total-rows="rowCount"
          :per-page="perPage"
          v-model="currentPage"
          prev-text="Предыдущая"
          next-text="Следующая"
          hide-goto-end-buttons
        />
      </nav>
    </b-card>
    <b-modal id="modalInfo" @hide="resetModal" title="Редактирование доступа" centered @ok="edit" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Логин</label>
          <b-form-input type="text"  placeholder="логин" v-model="modalInfo.login"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Пароль</label>
          <b-form-input type="password"  placeholder="пароль" v-model="modalInfo.password"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Доступ</label>
          <b-form-select v-model="modalInfo.level" :options="levels">
          </b-form-select>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" :disabled="disabled" block @click="edit">Изменить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
<!-- -------------------------------------------------------------------------------------------------------------- -->

    <b-modal id="addingModal" @hide="resetModal" title="Добавление пользователя" centered @ok="adding" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Логин</label>
          <b-form-input type="text" name="addedModal.login" placeholder="логин" v-model="addedModal.login"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Пароль</label>
          <b-form-input type="password" name="addedModal.password" placeholder="пароль" v-model="addedModal.password"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Доступ</label>
          <b-form-select v-model="addedModal.level" :options="levels"  name="level"></b-form-select>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" :disabled="disabled" block @click="adding">Добавить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
  </b-container>
</template>

<script>
import Api from '@/services/Api'
export default {
    props: {
    caption: {
      type: String,
      default: 'Логистика'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      items: [],
      levels: [
        { value: 0, text: 'Админ' },
        { value: 1, text: 'Склад' },
        { value: 2, text: 'Офис' }
      ],
      fields: [
        { key: "login", sortable: true, label: "Логин" },
        { key: "level", sortable: true, label: "Доступ"},
        { key: 'action', sortable: true, label: 'Действия по данным' }
        ],
      currentPage: 1,
      perPage: 0,
      rowCount: 0,
      modalInfo: {
        _id: '',
        login: '',
        password: '',
        level: 0
      },
      addedModal: {
        login: '',
        password: '',
        level: 0
      },
    }
  },
  created () {
    this.getList()
  },
  computed: {
    tableData() {
      return this.items.map(item => {
        return {
          login: item.login,
          level: item.level === 0 ? 'Админ': item.level === 1 ? 'Склад' : 'Офис',
          _id: item._id,
          password: item.password
        }
      })
    },
    disabled () {
      if (this.addedModal.login && this.addedModal.password || this.modalInfo.login && this.modalInfo.password) {
        return false
      } else {
        return true
      }
    }
  },
  methods: {
    async getList() {
      const response = await Api().get('admins/list');
      this.items = response.data.admins;
    },
    adding (e) {
      Api().post('admins/add', this.addedModal).then(response => {
        this.getList()
        this.$root.$emit('bv::hide::modal', 'addingModal')
        this.resetModal()
      })
    },
    edit (e) {
      Api().post('admins/edit', this.modalInfo).then(response => {
        this.getList()
        this.$root.$emit('bv::hide::modal', 'modalInfo')
        this.resetModal()
      })
    },
    deleting (_id) {
      console.log('deleting id = ', _id)
      const answer = confirm('Нажмите OK для продолжения или Cancel для выхода.')
      if (answer) {
        Api().post('admins/delete', {_id}).then(response => {
            this.getList()
            this.resetModal()
        })
      } else {
        this.resetModal()
      }
    },
    info (_item) {
      // this.modalInfo = this.items.find(_item._id)
      this.modalInfo = this.items.find(item => item._id === _item._id)
      this.$root.$emit('bv::show::modal', 'modalInfo')
    },
    resetModal () {
      this.addedModal = {
        login: '',
        password: '',
        level: ''
      },
      this.modalInfo = {
        _id: '',
        login: '',
        password: '',
        level: ''
      }
    },
    openAddingModal () {
      this.$root.$emit('bv::show::modal', 'addingModal')
    },
  }
};
</script>

<style>
</style>
